//
//  ViewController.m
//  Stanford_Cal_Assignment_1
//
//  Created by LauRi3A on 1/07/12.
//  Copyright (c) 2012 Beginning. All rights reserved.
//

#import "ViewController.h"
#import "CalculatorBrain.h"

@interface ViewController ()
@property (nonatomic) BOOL userIsInTheMiddleOfEnteringANumber;
@property (nonatomic, strong) CalculatorBrain *brain;
@property (nonatomic) BOOL userHasAlreadyPressedDot;
@property (nonatomic) BOOL userHasAlreadyPressedEnter;
@end

@implementation ViewController
@synthesize displayLabel = _displayLabel;
@synthesize historyLabel = _historyLabel;
@synthesize userIsInTheMiddleOfEnteringANumber = _userIsInTheMiddleOfEnteringANumber;
@synthesize userHasAlreadyPressedDot = _userHasAlreadyPressedDot;
@synthesize brain = _brain;

-(CalculatorBrain *)brain
{
    if (!_brain) _brain = [[CalculatorBrain alloc] init];
    return _brain;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
}

-(IBAction)DigitPress:(UIButton *)sender
{
    NSString *digit = sender.currentTitle;
    if (self.userIsInTheMiddleOfEnteringANumber) {
        self.displayLabel.text = [self.displayLabel.text stringByAppendingString:digit];
    }
    else
    {
        if ([digit isEqual:@"0"]) {
        }
        else
        {
            self.displayLabel.text = digit;
            self.userIsInTheMiddleOfEnteringANumber = YES;
        }
    }
    self.userHasAlreadyPressedEnter = NO;
}
- (void)descriptionDisplay:(NSString *)inputString{

    self.historyLabel.text = [self.historyLabel.text stringByReplacingOccurrencesOfString:@"=" withString:@""];
    self.historyLabel.text = [self.historyLabel.text stringByAppendingString:inputString];
    self.historyLabel.text = [self.historyLabel.text stringByAppendingString:@" ="];
    
}
- (IBAction)test1Pressed{
    
    CalculatorBrain *testBrain = [self brain];
    
    [testBrain pushVariable:@"a"];
    [testBrain pushVariable:@"a"];
    [testBrain pushOperation:@"*"];
    [testBrain pushVariable:@"b"];
    [testBrain pushVariable:@"b"];
    [testBrain pushOperation:@"*"];
    [testBrain pushOperation:@"+"];
    [testBrain pushOperation:@"sqrt"];
    
    // Retrieve the program
    NSArray *program = testBrain.program;
    
    // Setup the dictionary
    NSDictionary *dictionary =
    [NSDictionary dictionaryWithObjectsAndKeys:
     [NSNumber numberWithDouble:3], @"a",
     [NSNumber numberWithDouble:4], @"b", nil];
    
    // Run the program with variables
    NSLog(@"Running the program with variables returns the value %g",
          [CalculatorBrain runProgram:program usingVariableValues:dictionary]);
    
    // List the variables in program
    NSLog(@"Variables in program are %@",
          [[CalculatorBrain variablesUsedInProgram:program] description]);
    
}

- (IBAction)enterPress{
    if (!self.userHasAlreadyPressedEnter) {
        self.historyLabel.text = [self.historyLabel.text stringByReplacingOccurrencesOfString:@"=" withString:@""];
        self.historyLabel.text = [self.historyLabel.text stringByAppendingString:self.displayLabel.text];
        self.historyLabel.text = [self.historyLabel.text stringByAppendingString:@" "];
        [self.brain pushOperand:[self.displayLabel.text doubleValue]];
        self.userIsInTheMiddleOfEnteringANumber = NO;
        self.userHasAlreadyPressedDot = NO;
        self.userHasAlreadyPressedEnter = YES;
    }
}

- (IBAction)backspaceBtn:(UIButton *)sender {
    self.displayLabel.text = [self.displayLabel.text substringToIndex:[self.displayLabel.text length] -1];
    if ([self.displayLabel.text isEqualToString:@""] || [self.displayLabel.text isEqualToString:@"-"]) {
        self.displayLabel.text = @"0";
        self.userIsInTheMiddleOfEnteringANumber = NO;
    }
}


- (IBAction)operationPress:(UIButton *)sender {

    if (self.userIsInTheMiddleOfEnteringANumber) [self enterPress];
    self.displayLabel.text = [NSString stringWithFormat:@"%g", [self.brain performOperation:sender.currentTitle]];
    [self descriptionDisplay:sender.currentTitle];
    if ([sender.currentTitle isEqualToString:@"C"]) {
        self.userIsInTheMiddleOfEnteringANumber = NO;
        self.userHasAlreadyPressedDot = NO;
        self.displayLabel.text = @"0";
        self.historyLabel.text = @"";
    }
}
    
- (IBAction)SignChange:(UIButton *)sender {
    if (self.userIsInTheMiddleOfEnteringANumber) {
        if ([[self.displayLabel.text substringToIndex:1] isEqualToString:@"-"]) {
            self.displayLabel.text = [self.displayLabel.text substringFromIndex:1];
        } else {
            self.displayLabel.text = [@"-" stringByAppendingString:self.displayLabel.text];
        }
    } else
        [self operationPress:sender];
}

- (IBAction)dotPress:(id)sender {
    
//    NSRange range = [self.displayLabel.text rangeOfString:@"."];
//    if (range.location == NSNotFound) {
//        self.displayLabel.text = [self.displayLabel.text stringByAppendingString:@"."];
//    }
//    self.userIsInTheMiddleOfEnteringANumber = YES;
    
    if (!self.userHasAlreadyPressedDot) {
        if (!self.userIsInTheMiddleOfEnteringANumber) {
            self.displayLabel.text = @"0.";
        }
            else {
            self.displayLabel.text = [self.displayLabel.text stringByAppendingString:@"."];
        }
    }
    self.userHasAlreadyPressedDot = YES;
    self.userIsInTheMiddleOfEnteringANumber = YES;
}
@end
